/* Copyright (C) Arm Limited, 2020 All rights reserved. 
 * The example code is provided to you as an aid to learning when working 
 * with Arm-based technology, including but not limited to programming tutorials. 
 * Arm hereby grants to you, subject to the terms and conditions of this Licence, 
 * a non-exclusive, non-transferable, non-sub-licensable, free-of-charge licence, 
 * to use and copy the Software solely for the purpose of demonstration and 
 * evaluation.
 * You accept that the Software has not been tested by Arm therefore the Software 
 * is provided "as is", without warranty of any kind, express or implied. In no 
 * event shall the authors or copyright holders be liable for any claim, damages 
 * or other liability, whether in action or contract, tort or otherwise, arising 
 * from, out of or in connection with the Software or the use of Software.
 */

#include "arm_math.h"

void arm_clip_f32(float32_t * pSrc, float32_t * pDst, float32_t low, float32_t high, uint32_t numSamples) {
  for (uint32_t i = 0; i < numSamples; i++) {
    if (pSrc[i] > high)
      pDst[i] = high;
    else if (pSrc[i] < low)
      pDst[i] = low;
    else
      pDst[i] = pSrc[i];
  }
}

