/* Copyright (C) Arm Limited, 2020 All rights reserved. 
 * The example code is provided to you as an aid to learning when working 
 * with Arm-based technology, including but not limited to programming tutorials. 
 * Arm hereby grants to you, subject to the terms and conditions of this Licence, 
 * a non-exclusive, non-transferable, non-sub-licensable, free-of-charge licence, 
 * to use and copy the Software solely for the purpose of demonstration and 
 * evaluation.
 * You accept that the Software has not been tested by Arm therefore the Software 
 * is provided "as is", without warranty of any kind, express or implied. In no 
 * event shall the authors or copyright holders be liable for any claim, damages 
 * or other liability, whether in action or contract, tort or otherwise, arising 
 * from, out of or in connection with the Software or the use of Software.
 */

     .globl     my_maximum_u32
     .p2align   2
     .type      my_maximum_u32,%function
			
my_maximum_u32:                    // Function "my_maximum_u32" entry point.
     .fnstart
     push       {r7, lr}           // Save LR
     vmov.i32   q0, #0x0           // Initialize Q0 
     wlstp.32   lr, r1, end        // Loop Start... 
loop:                                
     vldrw.u32  q1, [r0], #16      //    Load 4 values into vector and increment pointer
     vmax.u32   q0, q1, q0         //    Find maximum
     letp       lr, loop           // ...Loop End
end:
     movs       r0, #0             // Initialize return value to zero
     vmaxv.u32  r0, q0             // Get maximum across all lanes in result vector
     str        r0, [r2]           // Store at address of result pointer
     pop        {r7, pc}           // Return by setting PC to saved LR
     .fnend
